//============================================================
// CONSOLE.HH
// ROBERT MUTH
// 08.03.96
//============================================================

#ifndef CONSOLE_H
#define CONSOLE_H

#include <X11/X.h>
#include <X11/Xlib.h>

#include "combat.hh"

class Console
{
private:
    Display         *display;
    int             screen;
    int             depth;
    Window          window;
    Pixmap          bitmap;

    XFontStruct     *font;

    GC              gc[nColors];

public:
    Console(char *displaystring, int w, int h);

    ~Console();
    
    void DrawText(char *text, int length, double x, double y, Color color);
    
    void DrawLine(double x1, double y1, double x2, double y2, Color color);
    
    void DrawRectangle(double x, double y, double w, double h, Color color);
    
    void DrawFilledCircle(double x, double y, double r, Color color);

    void DrawCircle(double x, double y, double r, Color color);
    
    void UpdateArea(double x, double y, double w, double h);

    void SetTitle(char *text);
    
    Action GetEvent();

    void Sync();
};

#endif // CONSOLE_H


