


/*
Combat - A tank simulation for X written in C++

Copyright (C) 1997,1998 Robert Muth <muth@cs.arizona.edu>

This program is free software; you can redistribute it and/or modify it under the terms of 
the GNU General Public License as published by the Free Software Foundation; version 2 (June 1991)

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, 
write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


//============================================================
// PLAYER.CC
// ROBERT MUTH
// 08.03.96
//============================================================

#include "combat.hh"
#include "player.hh"

#include <stream.h>

void Player::EventHandler()
{
    Action a;

    while( NoAction != (a = GetEvent()) )
    {
        switch(a)
        {
        case Quit:
            exit(-1);
            break;
        case Place:
            if( !isActive() )
                tank = PlaceTank(this);
            break;
        case Fire:
            if( isActive() && hasShots() )
            {
                shots--;
                FireShot(tank);
            }
            break;
        case LeftOn:
            left = true;
            break;
        case LeftOff:
            left = false;
            break;
        case RightOn:
            right = true;
            break;
        case RightOff:
            right = false;
            break;
        case BackwardOn:
            backward = true;
            break;
        case BackwardOff:
            backward = false;
            break;
        case ForwardOn:
            forward = true;
            break;
        case ForwardOff:
            forward = false;
            break;
        case HideOn:
            hide = true;
            break;
        case HideOff:
            hide = false;
            break;
        case NoAction:
            break;
        }
    }

    if( isActive() &&  isHidden() )
    {
        invisibility--;
        if( invisibility < 0 )
            hide = false;
    }
    
        
}



void Player::UpdateTitle()
{
    int i;

    char buf[256];

    for(i=0; i<lives; i++)
        buf[i] = '#';

    for( ; i<NLIVES; i++)
        buf[i] = '_';

    buf[i] = 0;

    SetTitle(buf);
}


void Player::TankKilled()
{
    tank = 0;
    lives--;
    UpdateTitle();
}

void Player::ShotKilled()
{
    shots++;
}
