//============================================================
// PLAYER.HH
// ROBERT MUTH
// 08.03.96
//============================================================

#ifndef PLAYER_H
#define PLAYER_H

#include "combat.hh"
#include "console.hh"


class Player : public Console
{
protected:
    bool            forward;
    bool            backward;
    bool            left;
    bool            right;
    bool            hide;

    int             invisibility;    
    int             lives;
    int             shots;

    Tank           *tank;
    
public:    
    ~Player();

    Player(char *displaystring, int w, int h) : Console(displaystring, w, h),
        forward(false),backward(false),left(false),right(false),hide(false),
        invisibility(INVISIBILITY), lives(NLIVES), shots(NSHOTS), tank(0)
            {
                UpdateTitle();
            }

    bool hasShots()
        {
            return (shots > 0);
        }
    
    bool isAlive()
    {
        return (lives > 0);
    }
    
    bool isActive()
        {
            return (tank != 0);
        }

    bool isHidden()
        {
            return hide;
        }

    bool turnLeft()
        {
            return left;
        }
    
    bool turnRight()
        {
            return right;
        }
       
    bool moveForward()
        {
            return forward;
        }

    bool moveBackward()
        {
            return backward;
        }
       
    void EventHandler();

    void ShotKilled();

    void TankKilled();

    void UpdateTitle();
};

#endif // PLAYER_H






